---
title: keySplines
slug: Web/SVG/Attribute/keySplines
tags:
  - SVG
  - SVG Attribute
---
<div>{{SVGRef}}</div>

<p>The <strong><code>keySplines</code></strong> attribute defines a set of {{Glossary("Bézier curve")}} control points associated with the {{SVGAttr("keyTimes")}} list, defining a cubic Bézier function that controls interval pacing.<br>
 <br>
 This attribute is ignored unless the {{SVGAttr("calcMode")}} attribute is set to <code>spline</code>.<br>
 <br>
 If there are any errors in the keySplines specification (bad values, too many or too few values), the animation will not occur.</p>

<p>Four elements are using this attribute: {{SVGElement("animate")}}, {{SVGElement("animateColor")}}, {{SVGElement("animateMotion")}}, and {{SVGElement("animateTransform")}}</p>

<div id="topExample">
<div class="hidden">
<pre class="brush: css">html, body, svg {
  height: 100%;
}</pre>
</div>

<pre class="brush: html; highlight[5,8]">&lt;svg viewBox="0 0 120 120" xmlns="http://www.w3.org/2000/svg"&gt;
  &lt;circle cx="60" cy="10" r="10"&gt;
    &lt;animate attributeName="cx" dur="4s" calcMode="spline" repeatCount="indefinite"
        values="60 ; 110 ; 60 ; 10 ; 60" keyTimes="0 ; 0.25 ; 0.5 ; 0.75 ; 1"
        keySplines="0.5 0 0.5 1 ; 0.5 0 0.5 1 ; 0.5 0 0.5 1 ; 0.5 0 0.5 1"/&gt;
    &lt;animate attributeName="cy" dur="4s" calcMode="spline" repeatCount="indefinite"
        values="10 ; 60 ; 110 ; 60 ; 10" keyTimes="0 ; 0.25 ; 0.5 ; 0.75 ; 1"
        keySplines="0.5 0 0.5 1 ; 0.5 0 0.5 1 ; 0.5 0 0.5 1 ; 0.5 0 0.5 1"/&gt;
  &lt;/circle&gt;
&lt;/svg&gt;</pre>

<p>{{EmbedLiveSample("topExample", "200", "200")}}</p>
</div>

<h2 id="Usage_notes">Usage notes</h2>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row">Value</th>
   <td><code>&lt;control-point&gt;</code> [ <code>;</code> <code>&lt;control-point&gt;</code> ]* <code>;</code>?</td>
  </tr>
  <tr>
   <th scope="row">Default value</th>
   <td><em>None</em></td>
  </tr>
  <tr>
   <th scope="row">Animatable</th>
   <td>No</td>
  </tr>
 </tbody>
</table>

<p>The attribute value is a semicolon-separated list of control point descriptions.</p>

<dl>
 <dt><code>&lt;control-point&gt;</code></dt>
 <dd>Each control point description is a set of four values: <code>x1 y1 x2 y2</code>, describing the Bézier control points for one time segment. The {{SVGAttr("keyTimes")}} values that define the associated segment are the Bézier "anchor points", and the <code>keySplines</code> values are the control points. Thus, there must be one fewer sets of control points than there are {{SVGAttr("keyTimes")}}.<br>
 <br>
 The values of <code>x1 y1 x2 y2</code> must all be in the range 0 to 1.</dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("SVG Animations 2", "#KeySplinesAttribute", "keySplines")}}</td>
   <td>{{Spec2("SVG Animations 2")}}</td>
   <td>No change</td>
  </tr>
  <tr>
   <td>{{SpecName("SVG1.1", "animate.html#KeySplinesAttribute", "keySplines")}}</td>
   <td>{{Spec2("SVG1.1")}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("svg.elements.animate.keySplines")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="https://en.wikipedia.org/wiki/B%C3%A9zier_curve">Wikipedia article on Bézier curves</a></li>
</ul>
